package com.tptj.demo.hg.sms.service.provider;

import com.fr.base.sms.SMSContext;
import com.fr.intelli.record.Focus;
import com.fr.json.JSONArray;
import com.fr.json.JSONObject;
import com.fr.log.FineLoggerFactory;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.stable.fun.impl.AbstractSMSServiceProvider;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author 秃破天际
 * @version 10.0
 * Created by 秃破天际 on 2021-06-03
 **/
@EnableMetrics
public class Demo extends AbstractSMSServiceProvider {
    static {
        SMSContext.addSmsListener(new Listener(){
            @Override
            public void beforeSend(String text, List<String> mobiles, JSONArray params, List<String> receivers) {
                FineLoggerFactory.getLogger().info("SMS Demo Fire beforeSend");
            }

            @Override
            public void afterSend(String text, List<String> mobiles, JSONArray params, List<String> receivers, Response response) {
                FineLoggerFactory.getLogger().info("SMS Demo Fire afterSend");
            }
        });
    }
    @Override
    @Focus(id="com.tptj.demo.hg.sms.service.provider.v10",text = "sms service provider")
    public Map<String, String> mapping() {
        //随便写的，自己实现是要写全，否则下面的template就是null
        Map<String, String> map = new HashMap<String, String>(5);
        map.put("20","短信验证码是：${code}");
        map.put("2","2");
        map.put("3","3");
        map.put("4","4");
        map.put("5","5");
        return map;
    }

    @Override
    public Response sendTest(String mobile) {
        FineLoggerFactory.getLogger().info("SMS Demo sendTest({})",mobile);
        return Response.create(Response.RES_STATUS_SUCCESS,"123",JSONObject.create().put("a","b"));
    }

    @Override
    public Response send(String template, String mobile, JSONObject para, String receiver) throws Exception {
        FineLoggerFactory.getLogger().info("SMS Demo send({},{},{},{})",template,mobile,para.toString(),receiver);
        return Response.create(Response.RES_STATUS_SUCCESS,"123",JSONObject.create().put(mobile,template));
    }

    @Override
    public Response batchSendSMS(String template, List<String> mobiles, JSONArray params, List<String> receivers) throws Exception {
        FineLoggerFactory.getLogger().info("SMS Demo batchSendSMS({})",template);
        return Response.create(Response.RES_STATUS_SUCCESS,"123",JSONObject.create().put("k",template));
    }
}
